﻿// This script is given as is. The author is not responsible for any possible damage done due to the use of this code.
// This script can be used only in a documentation, that is created by the Precision Helper product.
// The code remains property of the author and may not be distributed, published, given or sold in any form
// without the purchased royalty-free license, that allows you to distribute this code as a part of your products.

// Copyright © 2009 - 2010  Precision software & consulting
// All rights reserved

function makeHighlightedNode(aChild)
{
	var node = window.parent.right.document.createElement('SPAN');
	node.style.backgroundColor = '#000099';
	node.style.color = '#ffffff';
	node.appendChild(aChild);
	return node;
}

function highlight(aWord, container)
{
	for(var i=0; i<container.childNodes.length; i++)
  {
		var node = container.childNodes[i];

		if (node.nodeType == 3)
    {
			var data = node.data;
			var lData = data.toLowerCase();
			if (lData.indexOf(aWord) != -1) {
				var new_node = window.parent.right.document.createElement('SPAN');
				node.parentNode.replaceChild(new_node,node);
				var result;
				while((result = lData.indexOf(aWord)) != -1){
					new_node.appendChild(window.parent.right.document.createTextNode(data.substr(0,result)));
					new_node.appendChild(makeHighlightedNode(window.parent.right.document.createTextNode(data.substr(result,aWord.length))));
					data = data.substr(result + aWord.length);
					lData = lData.substr(result + aWord.length);}
				new_node.appendChild(window.parent.right.document.createTextNode(data));}
		}
    else
      {highlight(aWord,node);}
	}
}

function checkHighlight()
{
  if (window.parent.right.document.body.childNodes.length>0)
  {
    if ((document.SearchForm!=undefined) && (document.SearchForm.searchtext.value!=''))
    {
      var j;
    	var srchexpr = document.SearchForm.searchtext.value.toLowerCase();
    	srchexpr = srchexpr.replace(/^\s*([\S\s]*)\b\s*$/, "$1");
    	var words = srchexpr.split(" ");
			for(j=0; j<words.length; j++) {
        if (words[j].indexOf("*")!=-1) {
            words[j] = words[j].substring(0,words[j].lastIndexOf("*"));}}
 			for(j=0; j<words.length; j++){
        highlight(words[j],window.parent.right.document.body);}
    }
  }
  return;
}

function doSearch(srchexpr)
{
	if(srchexpr.length != 0)
	{
    var mword;
  	var i,j,k,t,mw;
    var h,l,bi,c;
  	results.innerHTML='';
  	srchexpr = srchexpr.toLowerCase();
  	srchexpr = srchexpr.replace(/^\s*([\S\s]*)\b\s*$/, "$1");
  	var words = srchexpr.split(" ");

  	// clear counts
  	for(j = 0 ; j < stopics.length ; j++)
  	{
      stopics[j][2] = 0;
    }

  	if (srchexpr.indexOf("*")!=-1)
  	{
      // masked words
      mw = 0;
    	for(i = 0 ; i < words.length ; i++) {
        mword = words[i];
        t = mword.indexOf("*");
        if (t!=-1)
        {
          mword = mword.substring(0,mword.lastIndexOf("*"));
    		  for(j = 0 ; j < sindex.length ; j++) {
    			  if(sindex[j][0].indexOf(mword)==0) {
    			 	  for(k = 0 ; k < sindex[j][1].length ; k++)
    			 	    {
                  if (stopics[[sindex[j][1][k]]][2]>=mw)
                 stopics[[sindex[j][1][k]]][2] = mw+1;
                 }}}
          mw++;
        }
    	}

    	for(i = 0 ; i < words.length ; i++) {
        mword = words[i];
        if (mword.indexOf("*") == -1)
        {
    		  for(j = 0 ; j < sindex.length ; j++) {
    			  if(mword == sindex[j][0]) {
    			 	  for(k = 0 ; k < sindex[j][1].length ; k++)
    			 	    {stopics[[sindex[j][1][k]]][2]++;}
    			 	  break; } }
        }
    	}
    }
    else
    {
      for(i = 0 ; i < words.length ; i++) {
        j = -1;
        l = 0;
        h = sindex.length - 1;
        while (l<=h)
        {
          bi = (l + h) >> 1;
          c =  sindex[bi][0].localeCompare(words[i]);
          if (c < 0) {
            l = bi + 1
          }
          else {
            h = bi - 1;
            if (c == 0) {
              j = bi;
              l = bi;
            }
          }
        }
        if (j>=0)
        {
          for(k = 0 ; k < sindex[j][1].length ; k++)
  				  {stopics[[sindex[j][1][k]]][2]++;}
        }
      }
  	}

  	// add results with counts = all words
  	i = 0;
  	t = words.length;
    var sortArr = new Array();
  	for(j = 0 ; j < stopics.length ; j++)
  	{
      if (stopics[j][2] >= t)
      {
        sortArr[i] = new Array();
        sortArr[i][0] = stopics[j][0];
        sortArr[i][1] = stopics[j][1];
        i++;
      }
    }
    sortArr.sort();
    
    if (sortArr.length != 0)
    {
      var resHtml = "";
      for (i=0;i<sortArr.length;i++) {
        resHtml = resHtml +
          '<li><b><a href="' + sortArr[i][1] + '">' + sortArr[i][0] + '</a></b><br />' +
            sortArr[i][1] +
          '</li>'
      }
      results.innerHTML = resHtml;
    }

	}
	return false;
}
